// source: value.proto
/**
 * @fileoverview
 * @enhanceable
 * @suppress {messageConventions} JS Compiler reports an error if a variable or
 *     field starts with 'MSG_' and isn't a translatable message.
 * @public
 */
// GENERATED CODE -- DO NOT EDIT!

var jspb = require('google-protobuf');
var goog = jspb;
var global = Function('return this')();

goog.exportSymbol('proto.NullValue', null, global);
goog.exportSymbol('proto.Value', null, global);
goog.exportSymbol('proto.Value.ValueCase', null, global);
goog.exportSymbol('proto.ValueDict', null, global);
goog.exportSymbol('proto.ValueError', null, global);
goog.exportSymbol('proto.ValueList', null, global);
goog.exportSymbol('proto.ValueRaw', null, global);
goog.exportSymbol('proto.ValueRaw.RawCase', null, global);
goog.exportSymbol('proto.ValueType', null, global);
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.ValueError = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.ValueError, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.ValueError.displayName = 'proto.ValueError';
}
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.ValueList = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, proto.ValueList.repeatedFields_, null);
};
goog.inherits(proto.ValueList, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.ValueList.displayName = 'proto.ValueList';
}
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.ValueDict = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, null, null);
};
goog.inherits(proto.ValueDict, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.ValueDict.displayName = 'proto.ValueDict';
}
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.ValueRaw = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, null, proto.ValueRaw.oneofGroups_);
};
goog.inherits(proto.ValueRaw, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.ValueRaw.displayName = 'proto.ValueRaw';
}
/**
 * Generated by JsPbCodeGenerator.
 * @param {Array=} opt_data Optional initial data array, typically from a
 * server response, or constructed directly in Javascript. The array is used
 * in place and becomes part of the constructed object. It is not cloned.
 * If no data is provided, the constructed object will be empty, but still
 * valid.
 * @extends {jspb.Message}
 * @constructor
 */
proto.Value = function(opt_data) {
  jspb.Message.initialize(this, opt_data, 0, -1, null, proto.Value.oneofGroups_);
};
goog.inherits(proto.Value, jspb.Message);
if (goog.DEBUG && !COMPILED) {
  /**
   * @public
   * @override
   */
  proto.Value.displayName = 'proto.Value';
}



if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.ValueError.prototype.toObject = function(opt_includeInstance) {
  return proto.ValueError.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.ValueError} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.ValueError.toObject = function(includeInstance, msg) {
  var f, obj = {
    message: jspb.Message.getFieldWithDefault(msg, 1, "")
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.ValueError}
 */
proto.ValueError.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.ValueError;
  return proto.ValueError.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.ValueError} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.ValueError}
 */
proto.ValueError.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = /** @type {string} */ (reader.readString());
      msg.setMessage(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.ValueError.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.ValueError.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.ValueError} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.ValueError.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getMessage();
  if (f.length > 0) {
    writer.writeString(
      1,
      f
    );
  }
};


/**
 * optional string message = 1;
 * @return {string}
 */
proto.ValueError.prototype.getMessage = function() {
  return /** @type {string} */ (jspb.Message.getFieldWithDefault(this, 1, ""));
};


/**
 * @param {string} value
 * @return {!proto.ValueError} returns this
 */
proto.ValueError.prototype.setMessage = function(value) {
  return jspb.Message.setProto3StringField(this, 1, value);
};



/**
 * List of repeated fields within this message type.
 * @private {!Array<number>}
 * @const
 */
proto.ValueList.repeatedFields_ = [1];



if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.ValueList.prototype.toObject = function(opt_includeInstance) {
  return proto.ValueList.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.ValueList} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.ValueList.toObject = function(includeInstance, msg) {
  var f, obj = {
    itemsList: jspb.Message.toObjectList(msg.getItemsList(),
    proto.ValueRaw.toObject, includeInstance)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.ValueList}
 */
proto.ValueList.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.ValueList;
  return proto.ValueList.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.ValueList} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.ValueList}
 */
proto.ValueList.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = new proto.ValueRaw;
      reader.readMessage(value,proto.ValueRaw.deserializeBinaryFromReader);
      msg.addItems(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.ValueList.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.ValueList.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.ValueList} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.ValueList.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getItemsList();
  if (f.length > 0) {
    writer.writeRepeatedMessage(
      1,
      f,
      proto.ValueRaw.serializeBinaryToWriter
    );
  }
};


/**
 * repeated ValueRaw items = 1;
 * @return {!Array<!proto.ValueRaw>}
 */
proto.ValueList.prototype.getItemsList = function() {
  return /** @type{!Array<!proto.ValueRaw>} */ (
    jspb.Message.getRepeatedWrapperField(this, proto.ValueRaw, 1));
};


/**
 * @param {!Array<!proto.ValueRaw>} value
 * @return {!proto.ValueList} returns this
*/
proto.ValueList.prototype.setItemsList = function(value) {
  return jspb.Message.setRepeatedWrapperField(this, 1, value);
};


/**
 * @param {!proto.ValueRaw=} opt_value
 * @param {number=} opt_index
 * @return {!proto.ValueRaw}
 */
proto.ValueList.prototype.addItems = function(opt_value, opt_index) {
  return jspb.Message.addToRepeatedWrapperField(this, 1, opt_value, proto.ValueRaw, opt_index);
};


/**
 * Clears the list making it empty but non-null.
 * @return {!proto.ValueList} returns this
 */
proto.ValueList.prototype.clearItemsList = function() {
  return this.setItemsList([]);
};





if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.ValueDict.prototype.toObject = function(opt_includeInstance) {
  return proto.ValueDict.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.ValueDict} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.ValueDict.toObject = function(includeInstance, msg) {
  var f, obj = {
    itemsMap: (f = msg.getItemsMap()) ? f.toObject(includeInstance, proto.ValueRaw.toObject) : []
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.ValueDict}
 */
proto.ValueDict.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.ValueDict;
  return proto.ValueDict.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.ValueDict} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.ValueDict}
 */
proto.ValueDict.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = msg.getItemsMap();
      reader.readMessage(value, function(message, reader) {
        jspb.Map.deserializeBinary(message, reader, jspb.BinaryReader.prototype.readString, jspb.BinaryReader.prototype.readMessage, proto.ValueRaw.deserializeBinaryFromReader, "", new proto.ValueRaw());
         });
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.ValueDict.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.ValueDict.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.ValueDict} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.ValueDict.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getItemsMap(true);
  if (f && f.getLength() > 0) {
    f.serializeBinary(1, writer, jspb.BinaryWriter.prototype.writeString, jspb.BinaryWriter.prototype.writeMessage, proto.ValueRaw.serializeBinaryToWriter);
  }
};


/**
 * map<string, ValueRaw> items = 1;
 * @param {boolean=} opt_noLazyCreate Do not create the map if
 * empty, instead returning `undefined`
 * @return {!jspb.Map<string,!proto.ValueRaw>}
 */
proto.ValueDict.prototype.getItemsMap = function(opt_noLazyCreate) {
  return /** @type {!jspb.Map<string,!proto.ValueRaw>} */ (
      jspb.Message.getMapField(this, 1, opt_noLazyCreate,
      proto.ValueRaw));
};


/**
 * Clears values from the map. The map will be non-null.
 * @return {!proto.ValueDict} returns this
 */
proto.ValueDict.prototype.clearItemsMap = function() {
  this.getItemsMap().clear();
  return this;};



/**
 * Oneof group definitions for this message. Each group defines the field
 * numbers belonging to that group. When of these fields' value is set, all
 * other fields in the group are cleared. During deserialization, if multiple
 * fields are encountered for a group, only the last value seen will be kept.
 * @private {!Array<!Array<number>>}
 * @const
 */
proto.ValueRaw.oneofGroups_ = [[1,2,3,4,5,6,7,8]];

/**
 * @enum {number}
 */
proto.ValueRaw.RawCase = {
  RAW_NOT_SET: 0,
  NULL: 1,
  DOUBLE: 2,
  INT64: 3,
  BOOL: 4,
  STRING: 5,
  BYTES: 6,
  LIST: 7,
  DICT: 8
};

/**
 * @return {proto.ValueRaw.RawCase}
 */
proto.ValueRaw.prototype.getRawCase = function() {
  return /** @type {proto.ValueRaw.RawCase} */(jspb.Message.computeOneofCase(this, proto.ValueRaw.oneofGroups_[0]));
};



if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.ValueRaw.prototype.toObject = function(opt_includeInstance) {
  return proto.ValueRaw.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.ValueRaw} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.ValueRaw.toObject = function(includeInstance, msg) {
  var f, obj = {
    pb_null: jspb.Message.getFieldWithDefault(msg, 1, 0),
    pb_double: jspb.Message.getFloatingPointFieldWithDefault(msg, 2, 0.0),
    int64: jspb.Message.getFieldWithDefault(msg, 3, 0),
    bool: jspb.Message.getBooleanFieldWithDefault(msg, 4, false),
    string: jspb.Message.getFieldWithDefault(msg, 5, ""),
    bytes: msg.getBytes_asB64(),
    list: (f = msg.getList()) && proto.ValueList.toObject(includeInstance, f),
    dict: (f = msg.getDict()) && proto.ValueDict.toObject(includeInstance, f)
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.ValueRaw}
 */
proto.ValueRaw.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.ValueRaw;
  return proto.ValueRaw.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.ValueRaw} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.ValueRaw}
 */
proto.ValueRaw.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = /** @type {!proto.NullValue} */ (reader.readEnum());
      msg.setNull(value);
      break;
    case 2:
      var value = /** @type {number} */ (reader.readDouble());
      msg.setDouble(value);
      break;
    case 3:
      var value = /** @type {number} */ (reader.readInt64());
      msg.setInt64(value);
      break;
    case 4:
      var value = /** @type {boolean} */ (reader.readBool());
      msg.setBool(value);
      break;
    case 5:
      var value = /** @type {string} */ (reader.readString());
      msg.setString(value);
      break;
    case 6:
      var value = /** @type {!Uint8Array} */ (reader.readBytes());
      msg.setBytes(value);
      break;
    case 7:
      var value = new proto.ValueList;
      reader.readMessage(value,proto.ValueList.deserializeBinaryFromReader);
      msg.setList(value);
      break;
    case 8:
      var value = new proto.ValueDict;
      reader.readMessage(value,proto.ValueDict.deserializeBinaryFromReader);
      msg.setDict(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.ValueRaw.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.ValueRaw.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.ValueRaw} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.ValueRaw.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = /** @type {!proto.NullValue} */ (jspb.Message.getField(message, 1));
  if (f != null) {
    writer.writeEnum(
      1,
      f
    );
  }
  f = /** @type {number} */ (jspb.Message.getField(message, 2));
  if (f != null) {
    writer.writeDouble(
      2,
      f
    );
  }
  f = /** @type {number} */ (jspb.Message.getField(message, 3));
  if (f != null) {
    writer.writeInt64(
      3,
      f
    );
  }
  f = /** @type {boolean} */ (jspb.Message.getField(message, 4));
  if (f != null) {
    writer.writeBool(
      4,
      f
    );
  }
  f = /** @type {string} */ (jspb.Message.getField(message, 5));
  if (f != null) {
    writer.writeString(
      5,
      f
    );
  }
  f = /** @type {!(string|Uint8Array)} */ (jspb.Message.getField(message, 6));
  if (f != null) {
    writer.writeBytes(
      6,
      f
    );
  }
  f = message.getList();
  if (f != null) {
    writer.writeMessage(
      7,
      f,
      proto.ValueList.serializeBinaryToWriter
    );
  }
  f = message.getDict();
  if (f != null) {
    writer.writeMessage(
      8,
      f,
      proto.ValueDict.serializeBinaryToWriter
    );
  }
};


/**
 * optional NullValue null = 1;
 * @return {!proto.NullValue}
 */
proto.ValueRaw.prototype.getNull = function() {
  return /** @type {!proto.NullValue} */ (jspb.Message.getFieldWithDefault(this, 1, 0));
};


/**
 * @param {!proto.NullValue} value
 * @return {!proto.ValueRaw} returns this
 */
proto.ValueRaw.prototype.setNull = function(value) {
  return jspb.Message.setOneofField(this, 1, proto.ValueRaw.oneofGroups_[0], value);
};


/**
 * Clears the field making it undefined.
 * @return {!proto.ValueRaw} returns this
 */
proto.ValueRaw.prototype.clearNull = function() {
  return jspb.Message.setOneofField(this, 1, proto.ValueRaw.oneofGroups_[0], undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.ValueRaw.prototype.hasNull = function() {
  return jspb.Message.getField(this, 1) != null;
};


/**
 * optional double double = 2;
 * @return {number}
 */
proto.ValueRaw.prototype.getDouble = function() {
  return /** @type {number} */ (jspb.Message.getFloatingPointFieldWithDefault(this, 2, 0.0));
};


/**
 * @param {number} value
 * @return {!proto.ValueRaw} returns this
 */
proto.ValueRaw.prototype.setDouble = function(value) {
  return jspb.Message.setOneofField(this, 2, proto.ValueRaw.oneofGroups_[0], value);
};


/**
 * Clears the field making it undefined.
 * @return {!proto.ValueRaw} returns this
 */
proto.ValueRaw.prototype.clearDouble = function() {
  return jspb.Message.setOneofField(this, 2, proto.ValueRaw.oneofGroups_[0], undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.ValueRaw.prototype.hasDouble = function() {
  return jspb.Message.getField(this, 2) != null;
};


/**
 * optional int64 int64 = 3;
 * @return {number}
 */
proto.ValueRaw.prototype.getInt64 = function() {
  return /** @type {number} */ (jspb.Message.getFieldWithDefault(this, 3, 0));
};


/**
 * @param {number} value
 * @return {!proto.ValueRaw} returns this
 */
proto.ValueRaw.prototype.setInt64 = function(value) {
  return jspb.Message.setOneofField(this, 3, proto.ValueRaw.oneofGroups_[0], value);
};


/**
 * Clears the field making it undefined.
 * @return {!proto.ValueRaw} returns this
 */
proto.ValueRaw.prototype.clearInt64 = function() {
  return jspb.Message.setOneofField(this, 3, proto.ValueRaw.oneofGroups_[0], undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.ValueRaw.prototype.hasInt64 = function() {
  return jspb.Message.getField(this, 3) != null;
};


/**
 * optional bool bool = 4;
 * @return {boolean}
 */
proto.ValueRaw.prototype.getBool = function() {
  return /** @type {boolean} */ (jspb.Message.getBooleanFieldWithDefault(this, 4, false));
};


/**
 * @param {boolean} value
 * @return {!proto.ValueRaw} returns this
 */
proto.ValueRaw.prototype.setBool = function(value) {
  return jspb.Message.setOneofField(this, 4, proto.ValueRaw.oneofGroups_[0], value);
};


/**
 * Clears the field making it undefined.
 * @return {!proto.ValueRaw} returns this
 */
proto.ValueRaw.prototype.clearBool = function() {
  return jspb.Message.setOneofField(this, 4, proto.ValueRaw.oneofGroups_[0], undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.ValueRaw.prototype.hasBool = function() {
  return jspb.Message.getField(this, 4) != null;
};


/**
 * optional string string = 5;
 * @return {string}
 */
proto.ValueRaw.prototype.getString = function() {
  return /** @type {string} */ (jspb.Message.getFieldWithDefault(this, 5, ""));
};


/**
 * @param {string} value
 * @return {!proto.ValueRaw} returns this
 */
proto.ValueRaw.prototype.setString = function(value) {
  return jspb.Message.setOneofField(this, 5, proto.ValueRaw.oneofGroups_[0], value);
};


/**
 * Clears the field making it undefined.
 * @return {!proto.ValueRaw} returns this
 */
proto.ValueRaw.prototype.clearString = function() {
  return jspb.Message.setOneofField(this, 5, proto.ValueRaw.oneofGroups_[0], undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.ValueRaw.prototype.hasString = function() {
  return jspb.Message.getField(this, 5) != null;
};


/**
 * optional bytes bytes = 6;
 * @return {!(string|Uint8Array)}
 */
proto.ValueRaw.prototype.getBytes = function() {
  return /** @type {!(string|Uint8Array)} */ (jspb.Message.getFieldWithDefault(this, 6, ""));
};


/**
 * optional bytes bytes = 6;
 * This is a type-conversion wrapper around `getBytes()`
 * @return {string}
 */
proto.ValueRaw.prototype.getBytes_asB64 = function() {
  return /** @type {string} */ (jspb.Message.bytesAsB64(
      this.getBytes()));
};


/**
 * optional bytes bytes = 6;
 * Note that Uint8Array is not supported on all browsers.
 * @see http://caniuse.com/Uint8Array
 * This is a type-conversion wrapper around `getBytes()`
 * @return {!Uint8Array}
 */
proto.ValueRaw.prototype.getBytes_asU8 = function() {
  return /** @type {!Uint8Array} */ (jspb.Message.bytesAsU8(
      this.getBytes()));
};


/**
 * @param {!(string|Uint8Array)} value
 * @return {!proto.ValueRaw} returns this
 */
proto.ValueRaw.prototype.setBytes = function(value) {
  return jspb.Message.setOneofField(this, 6, proto.ValueRaw.oneofGroups_[0], value);
};


/**
 * Clears the field making it undefined.
 * @return {!proto.ValueRaw} returns this
 */
proto.ValueRaw.prototype.clearBytes = function() {
  return jspb.Message.setOneofField(this, 6, proto.ValueRaw.oneofGroups_[0], undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.ValueRaw.prototype.hasBytes = function() {
  return jspb.Message.getField(this, 6) != null;
};


/**
 * optional ValueList list = 7;
 * @return {?proto.ValueList}
 */
proto.ValueRaw.prototype.getList = function() {
  return /** @type{?proto.ValueList} */ (
    jspb.Message.getWrapperField(this, proto.ValueList, 7));
};


/**
 * @param {?proto.ValueList|undefined} value
 * @return {!proto.ValueRaw} returns this
*/
proto.ValueRaw.prototype.setList = function(value) {
  return jspb.Message.setOneofWrapperField(this, 7, proto.ValueRaw.oneofGroups_[0], value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.ValueRaw} returns this
 */
proto.ValueRaw.prototype.clearList = function() {
  return this.setList(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.ValueRaw.prototype.hasList = function() {
  return jspb.Message.getField(this, 7) != null;
};


/**
 * optional ValueDict dict = 8;
 * @return {?proto.ValueDict}
 */
proto.ValueRaw.prototype.getDict = function() {
  return /** @type{?proto.ValueDict} */ (
    jspb.Message.getWrapperField(this, proto.ValueDict, 8));
};


/**
 * @param {?proto.ValueDict|undefined} value
 * @return {!proto.ValueRaw} returns this
*/
proto.ValueRaw.prototype.setDict = function(value) {
  return jspb.Message.setOneofWrapperField(this, 8, proto.ValueRaw.oneofGroups_[0], value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.ValueRaw} returns this
 */
proto.ValueRaw.prototype.clearDict = function() {
  return this.setDict(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.ValueRaw.prototype.hasDict = function() {
  return jspb.Message.getField(this, 8) != null;
};



/**
 * Oneof group definitions for this message. Each group defines the field
 * numbers belonging to that group. When of these fields' value is set, all
 * other fields in the group are cleared. During deserialization, if multiple
 * fields are encountered for a group, only the last value seen will be kept.
 * @private {!Array<!Array<number>>}
 * @const
 */
proto.Value.oneofGroups_ = [[1,2,3,4,5,6,7]];

/**
 * @enum {number}
 */
proto.Value.ValueCase = {
  VALUE_NOT_SET: 0,
  ERROR: 1,
  RAW: 2,
  DATASET_URI: 3,
  CSV_URI: 4,
  PICKLE_URI: 5,
  PICKLE_BLOB: 6,
  PLASMA_ID: 7
};

/**
 * @return {proto.Value.ValueCase}
 */
proto.Value.prototype.getValueCase = function() {
  return /** @type {proto.Value.ValueCase} */(jspb.Message.computeOneofCase(this, proto.Value.oneofGroups_[0]));
};



if (jspb.Message.GENERATE_TO_OBJECT) {
/**
 * Creates an object representation of this proto.
 * Field names that are reserved in JavaScript and will be renamed to pb_name.
 * Optional fields that are not set will be set to undefined.
 * To access a reserved field use, foo.pb_<name>, eg, foo.pb_default.
 * For the list of reserved names please see:
 *     net/proto2/compiler/js/internal/generator.cc#kKeyword.
 * @param {boolean=} opt_includeInstance Deprecated. whether to include the
 *     JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @return {!Object}
 */
proto.Value.prototype.toObject = function(opt_includeInstance) {
  return proto.Value.toObject(opt_includeInstance, this);
};


/**
 * Static version of the {@see toObject} method.
 * @param {boolean|undefined} includeInstance Deprecated. Whether to include
 *     the JSPB instance for transitional soy proto support:
 *     http://goto/soy-param-migration
 * @param {!proto.Value} msg The msg instance to transform.
 * @return {!Object}
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.Value.toObject = function(includeInstance, msg) {
  var f, obj = {
    error: (f = msg.getError()) && proto.ValueError.toObject(includeInstance, f),
    raw: (f = msg.getRaw()) && proto.ValueRaw.toObject(includeInstance, f),
    datasetUri: jspb.Message.getFieldWithDefault(msg, 3, ""),
    csvUri: jspb.Message.getFieldWithDefault(msg, 4, ""),
    pickleUri: jspb.Message.getFieldWithDefault(msg, 5, ""),
    pickleBlob: msg.getPickleBlob_asB64(),
    plasmaId: msg.getPlasmaId_asB64()
  };

  if (includeInstance) {
    obj.$jspbMessageInstance = msg;
  }
  return obj;
};
}


/**
 * Deserializes binary data (in protobuf wire format).
 * @param {jspb.ByteSource} bytes The bytes to deserialize.
 * @return {!proto.Value}
 */
proto.Value.deserializeBinary = function(bytes) {
  var reader = new jspb.BinaryReader(bytes);
  var msg = new proto.Value;
  return proto.Value.deserializeBinaryFromReader(msg, reader);
};


/**
 * Deserializes binary data (in protobuf wire format) from the
 * given reader into the given message object.
 * @param {!proto.Value} msg The message object to deserialize into.
 * @param {!jspb.BinaryReader} reader The BinaryReader to use.
 * @return {!proto.Value}
 */
proto.Value.deserializeBinaryFromReader = function(msg, reader) {
  while (reader.nextField()) {
    if (reader.isEndGroup()) {
      break;
    }
    var field = reader.getFieldNumber();
    switch (field) {
    case 1:
      var value = new proto.ValueError;
      reader.readMessage(value,proto.ValueError.deserializeBinaryFromReader);
      msg.setError(value);
      break;
    case 2:
      var value = new proto.ValueRaw;
      reader.readMessage(value,proto.ValueRaw.deserializeBinaryFromReader);
      msg.setRaw(value);
      break;
    case 3:
      var value = /** @type {string} */ (reader.readString());
      msg.setDatasetUri(value);
      break;
    case 4:
      var value = /** @type {string} */ (reader.readString());
      msg.setCsvUri(value);
      break;
    case 5:
      var value = /** @type {string} */ (reader.readString());
      msg.setPickleUri(value);
      break;
    case 6:
      var value = /** @type {!Uint8Array} */ (reader.readBytes());
      msg.setPickleBlob(value);
      break;
    case 7:
      var value = /** @type {!Uint8Array} */ (reader.readBytes());
      msg.setPlasmaId(value);
      break;
    default:
      reader.skipField();
      break;
    }
  }
  return msg;
};


/**
 * Serializes the message to binary data (in protobuf wire format).
 * @return {!Uint8Array}
 */
proto.Value.prototype.serializeBinary = function() {
  var writer = new jspb.BinaryWriter();
  proto.Value.serializeBinaryToWriter(this, writer);
  return writer.getResultBuffer();
};


/**
 * Serializes the given message to binary data (in protobuf wire
 * format), writing to the given BinaryWriter.
 * @param {!proto.Value} message
 * @param {!jspb.BinaryWriter} writer
 * @suppress {unusedLocalVariables} f is only used for nested messages
 */
proto.Value.serializeBinaryToWriter = function(message, writer) {
  var f = undefined;
  f = message.getError();
  if (f != null) {
    writer.writeMessage(
      1,
      f,
      proto.ValueError.serializeBinaryToWriter
    );
  }
  f = message.getRaw();
  if (f != null) {
    writer.writeMessage(
      2,
      f,
      proto.ValueRaw.serializeBinaryToWriter
    );
  }
  f = /** @type {string} */ (jspb.Message.getField(message, 3));
  if (f != null) {
    writer.writeString(
      3,
      f
    );
  }
  f = /** @type {string} */ (jspb.Message.getField(message, 4));
  if (f != null) {
    writer.writeString(
      4,
      f
    );
  }
  f = /** @type {string} */ (jspb.Message.getField(message, 5));
  if (f != null) {
    writer.writeString(
      5,
      f
    );
  }
  f = /** @type {!(string|Uint8Array)} */ (jspb.Message.getField(message, 6));
  if (f != null) {
    writer.writeBytes(
      6,
      f
    );
  }
  f = /** @type {!(string|Uint8Array)} */ (jspb.Message.getField(message, 7));
  if (f != null) {
    writer.writeBytes(
      7,
      f
    );
  }
};


/**
 * optional ValueError error = 1;
 * @return {?proto.ValueError}
 */
proto.Value.prototype.getError = function() {
  return /** @type{?proto.ValueError} */ (
    jspb.Message.getWrapperField(this, proto.ValueError, 1));
};


/**
 * @param {?proto.ValueError|undefined} value
 * @return {!proto.Value} returns this
*/
proto.Value.prototype.setError = function(value) {
  return jspb.Message.setOneofWrapperField(this, 1, proto.Value.oneofGroups_[0], value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.Value} returns this
 */
proto.Value.prototype.clearError = function() {
  return this.setError(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.Value.prototype.hasError = function() {
  return jspb.Message.getField(this, 1) != null;
};


/**
 * optional ValueRaw raw = 2;
 * @return {?proto.ValueRaw}
 */
proto.Value.prototype.getRaw = function() {
  return /** @type{?proto.ValueRaw} */ (
    jspb.Message.getWrapperField(this, proto.ValueRaw, 2));
};


/**
 * @param {?proto.ValueRaw|undefined} value
 * @return {!proto.Value} returns this
*/
proto.Value.prototype.setRaw = function(value) {
  return jspb.Message.setOneofWrapperField(this, 2, proto.Value.oneofGroups_[0], value);
};


/**
 * Clears the message field making it undefined.
 * @return {!proto.Value} returns this
 */
proto.Value.prototype.clearRaw = function() {
  return this.setRaw(undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.Value.prototype.hasRaw = function() {
  return jspb.Message.getField(this, 2) != null;
};


/**
 * optional string dataset_uri = 3;
 * @return {string}
 */
proto.Value.prototype.getDatasetUri = function() {
  return /** @type {string} */ (jspb.Message.getFieldWithDefault(this, 3, ""));
};


/**
 * @param {string} value
 * @return {!proto.Value} returns this
 */
proto.Value.prototype.setDatasetUri = function(value) {
  return jspb.Message.setOneofField(this, 3, proto.Value.oneofGroups_[0], value);
};


/**
 * Clears the field making it undefined.
 * @return {!proto.Value} returns this
 */
proto.Value.prototype.clearDatasetUri = function() {
  return jspb.Message.setOneofField(this, 3, proto.Value.oneofGroups_[0], undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.Value.prototype.hasDatasetUri = function() {
  return jspb.Message.getField(this, 3) != null;
};


/**
 * optional string csv_uri = 4;
 * @return {string}
 */
proto.Value.prototype.getCsvUri = function() {
  return /** @type {string} */ (jspb.Message.getFieldWithDefault(this, 4, ""));
};


/**
 * @param {string} value
 * @return {!proto.Value} returns this
 */
proto.Value.prototype.setCsvUri = function(value) {
  return jspb.Message.setOneofField(this, 4, proto.Value.oneofGroups_[0], value);
};


/**
 * Clears the field making it undefined.
 * @return {!proto.Value} returns this
 */
proto.Value.prototype.clearCsvUri = function() {
  return jspb.Message.setOneofField(this, 4, proto.Value.oneofGroups_[0], undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.Value.prototype.hasCsvUri = function() {
  return jspb.Message.getField(this, 4) != null;
};


/**
 * optional string pickle_uri = 5;
 * @return {string}
 */
proto.Value.prototype.getPickleUri = function() {
  return /** @type {string} */ (jspb.Message.getFieldWithDefault(this, 5, ""));
};


/**
 * @param {string} value
 * @return {!proto.Value} returns this
 */
proto.Value.prototype.setPickleUri = function(value) {
  return jspb.Message.setOneofField(this, 5, proto.Value.oneofGroups_[0], value);
};


/**
 * Clears the field making it undefined.
 * @return {!proto.Value} returns this
 */
proto.Value.prototype.clearPickleUri = function() {
  return jspb.Message.setOneofField(this, 5, proto.Value.oneofGroups_[0], undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.Value.prototype.hasPickleUri = function() {
  return jspb.Message.getField(this, 5) != null;
};


/**
 * optional bytes pickle_blob = 6;
 * @return {!(string|Uint8Array)}
 */
proto.Value.prototype.getPickleBlob = function() {
  return /** @type {!(string|Uint8Array)} */ (jspb.Message.getFieldWithDefault(this, 6, ""));
};


/**
 * optional bytes pickle_blob = 6;
 * This is a type-conversion wrapper around `getPickleBlob()`
 * @return {string}
 */
proto.Value.prototype.getPickleBlob_asB64 = function() {
  return /** @type {string} */ (jspb.Message.bytesAsB64(
      this.getPickleBlob()));
};


/**
 * optional bytes pickle_blob = 6;
 * Note that Uint8Array is not supported on all browsers.
 * @see http://caniuse.com/Uint8Array
 * This is a type-conversion wrapper around `getPickleBlob()`
 * @return {!Uint8Array}
 */
proto.Value.prototype.getPickleBlob_asU8 = function() {
  return /** @type {!Uint8Array} */ (jspb.Message.bytesAsU8(
      this.getPickleBlob()));
};


/**
 * @param {!(string|Uint8Array)} value
 * @return {!proto.Value} returns this
 */
proto.Value.prototype.setPickleBlob = function(value) {
  return jspb.Message.setOneofField(this, 6, proto.Value.oneofGroups_[0], value);
};


/**
 * Clears the field making it undefined.
 * @return {!proto.Value} returns this
 */
proto.Value.prototype.clearPickleBlob = function() {
  return jspb.Message.setOneofField(this, 6, proto.Value.oneofGroups_[0], undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.Value.prototype.hasPickleBlob = function() {
  return jspb.Message.getField(this, 6) != null;
};


/**
 * optional bytes plasma_id = 7;
 * @return {!(string|Uint8Array)}
 */
proto.Value.prototype.getPlasmaId = function() {
  return /** @type {!(string|Uint8Array)} */ (jspb.Message.getFieldWithDefault(this, 7, ""));
};


/**
 * optional bytes plasma_id = 7;
 * This is a type-conversion wrapper around `getPlasmaId()`
 * @return {string}
 */
proto.Value.prototype.getPlasmaId_asB64 = function() {
  return /** @type {string} */ (jspb.Message.bytesAsB64(
      this.getPlasmaId()));
};


/**
 * optional bytes plasma_id = 7;
 * Note that Uint8Array is not supported on all browsers.
 * @see http://caniuse.com/Uint8Array
 * This is a type-conversion wrapper around `getPlasmaId()`
 * @return {!Uint8Array}
 */
proto.Value.prototype.getPlasmaId_asU8 = function() {
  return /** @type {!Uint8Array} */ (jspb.Message.bytesAsU8(
      this.getPlasmaId()));
};


/**
 * @param {!(string|Uint8Array)} value
 * @return {!proto.Value} returns this
 */
proto.Value.prototype.setPlasmaId = function(value) {
  return jspb.Message.setOneofField(this, 7, proto.Value.oneofGroups_[0], value);
};


/**
 * Clears the field making it undefined.
 * @return {!proto.Value} returns this
 */
proto.Value.prototype.clearPlasmaId = function() {
  return jspb.Message.setOneofField(this, 7, proto.Value.oneofGroups_[0], undefined);
};


/**
 * Returns whether this field is set.
 * @return {boolean}
 */
proto.Value.prototype.hasPlasmaId = function() {
  return jspb.Message.getField(this, 7) != null;
};


/**
 * @enum {number}
 */
proto.ValueType = {
  VALUE_TYPE_UNDEFINED: 0,
  RAW: 1,
  DATASET_URI: 2,
  CSV_URI: 3,
  PICKLE_URI: 4,
  PICKLE_BLOB: 5,
  PLASMA_ID: 6,
  LARGE_RAW: 7,
  LARGE_PICKLE_BLOB: 8
};

/**
 * @enum {number}
 */
proto.NullValue = {
  NULL_VALUE: 0
};

goog.object.extend(exports, proto);
